{"openapi":"3.0.1","info":{"title":"NeoWs - (NearEarthObject Web-Service)","description":"A web service for near earth objects. All the data is from the <a href=\"http://neo.jpl.nasa.gov/\" target=\"_blank\">NASA JPL Asteroid team</a>. \n\n \n\n\nNeoWs is proud to power AsteroidTracker on <a href=\"https://itunes.apple.com/us/app/asteroid-tracker/id689684901?mt=8\" target=\"_blank\">iOS</a> and\n<a href=\"https://play.google.com/store/apps/details?id=com.vitruviussoftware.bunifish.asteroidtracker&feature\" target=\"_blank\">Android</a> as well as related apps. \n\n\nFollow us on <a href=\"https://twitter.com/AsteroidTracker\" target=\"_blank\">Twitter</a>\n","contact":{"name":"NeoWs - SpaceRocks Team","url":"https://twitter.com/AsteroidTracker","email":"spacerocksapps@gmail.com"}},"servers":[{"url":"https://www.neowsapp.com","description":"Generated server url"}],"security":[{"api_key":[]}],"tags":[{"name":"2. NEO Rest Service","description":"Find an Asteroid by Id"},{"name":"3. Sentry Rest Service","description":"Data by the NASA JPL Sentry System"},{"name":"1. Date Rest Service","description":"Find Asteroids for Today or by a Date range"},{"name":"4. Stats Rest Service","description":"Stats on Near Earth Object data sets"}],"paths":{"/rest/v1/stats":{"get":{"tags":["4. Stats Rest Service"],"summary":"Get the Near Earth Object data set totals","operationId":"retrieveCurrentNeoStatistics","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Statistics"}}}}}}},"/rest/v1/neo/{asteroid_id}":{"get":{"tags":["2. NEO Rest Service"],"summary":"Find Near Earth Objects by id","description":"Retrieve a Near Earth Object by the SPKID or Asteroid Name","operationId":"retrieveNearEarthObjectById","parameters":[{"name":"asteroid_id","in":"path","description":"ID of Near Earth Object - (ex: 3729835)","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NearEarthObject"}}}}}}},"/rest/v1/neo/sentry":{"get":{"tags":["3. Sentry Rest Service"],"summary":"Retrieve Sentry (Impact Risk ) Near Earth Objects","description":"Retrieves Near Earth Objects listed in the NASA sentry data set","operationId":"retrieveSentryRiskData","parameters":[{"name":"is_active","in":"query","description":"show current list of Sentry objects, or show removed Sentry objects","required":false,"schema":{"type":"boolean","default":true}},{"name":"page","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":0}},{"name":"size","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":50}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SentryObjectPagingDto"}}}}}}},"/rest/v1/neo/sentry/{asteroid_id}":{"get":{"tags":["3. Sentry Rest Service"],"summary":"Retrieve Sentry (Impact Risk ) Near Earth Objectby ID ","description":"Retrieves Sentry Near Earth Object by ID","operationId":"retrieveSentryRiskDataById","parameters":[{"name":"asteroid_id","in":"path","description":"ID of NearEarth object.  ID can be SPK_ID, Asteroid des (designation) or Sentry ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SentryImpactRiskObject"}}}}}}},"/rest/v1/neo/browse":{"get":{"tags":["2. NEO Rest Service"],"summary":"Browse the Near Earth Objects service","description":"Retieve a paginated list of Near Earth Objects","operationId":"browseNearEarthObjects","parameters":[{"name":"page","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":0}},{"name":"size","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":20}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NearEarthObjectRestPagingDto"}}}}}}},"/rest/v1/feed":{"get":{"tags":["1. Date Rest Service"],"summary":"Find Near Earth Objects by date","description":"Get a list of Near Earth Objects within a date range, The max range in one query is 7 days","operationId":"retrieveNearEarthObjectFeed","parameters":[{"name":"start_date","in":"query","description":"Start of date range search, format: yyyy-MM-dd - (ex: 2015-04-28)","required":false,"schema":{"type":"string","default":""}},{"name":"end_date","in":"query","description":"End of date range search, format: yyyy-MM-dd - (ex: 2015-04-28). If left off search will extends 7 days from start_date","required":false,"schema":{"type":"string","default":""}},{"name":"detailed","in":"query","required":false,"schema":{"type":"boolean"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NearEarthObjectRestDto"}}}}}}},"/rest/v1/feed/today":{"get":{"tags":["1. Date Rest Service"],"summary":"Find Near Earth Objects for today","description":"Get a list of Near Earth Objects for today","operationId":"retrieveNEOFeedToday","parameters":[{"name":"detailed","in":"query","required":false,"schema":{"type":"boolean"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NearEarthObjectRestDto"}}}}}}}},"components":{"schemas":{"Statistics":{"type":"object","properties":{"id":{"type":"string"},"near_earth_object_count":{"title":"Number of NearEarthObjects listed in NeoWs","type":"integer","format":"int64"},"close_approach_count":{"title":"Number of Close Approach listings across all NEOs listed in NeoWs","type":"integer","format":"int64"},"last_updated":{"title":"TimeStamp the last time the DB was updated","type":"string"},"source":{"type":"string"},"nasa_jpl_url":{"type":"string","format":"url"}}},"CloseApproachData":{"title":"Close approach information of the Asteroid","type":"object","properties":{"close_approach_date":{"type":"string"},"close_approach_date_full":{"type":"string"},"epoch_date_close_approach":{"type":"integer","format":"int64"},"relative_velocity":{"$ref":"#/components/schemas/RelVelocity"},"miss_distance":{"$ref":"#/components/schemas/MissDistance"},"orbiting_body":{"type":"string"}}},"EstimatedDiameter":{"title":"EstimatedDiameter","type":"object","properties":{"estimated_diameter_min":{"title":"An estimate of the minimum size of the Asteroid - bases on the abosolute magnitude","type":"number","format":"double"},"estimated_diameter_max":{"title":"An estimate of the maximum size of the Asteroid - bases on the abosolute magnitude","type":"number","format":"double"}}},"EstimatedDiameterContainer":{"title":"A collection of estimated diameters (kilometers, meters, miles, feet","type":"object","properties":{"kilometers":{"$ref":"#/components/schemas/EstimatedDiameter"},"meters":{"$ref":"#/components/schemas/EstimatedDiameter"},"miles":{"$ref":"#/components/schemas/EstimatedDiameter"},"feet":{"$ref":"#/components/schemas/EstimatedDiameter"}}},"MissDistance":{"type":"object","properties":{"astronomical":{"type":"string"},"lunar":{"type":"string"},"kilometers":{"type":"string"},"miles":{"type":"string"}}},"NearEarthObject":{"title":"NearEarthObject","type":"object","properties":{"links":{"type":"object","additionalProperties":{"type":"string","readOnly":true},"readOnly":true},"id":{"type":"string","readOnly":true},"neo_reference_id":{"title":"The reference ID of the Asteroid - This correlates to the SPK ID for the JPL NEO data","type":"string"},"name":{"type":"string"},"name_limited":{"type":"string"},"designation":{"type":"string"},"nasa_jpl_url":{"title":"A Link to the NASA JPL Small-Body Database website","type":"string"},"absolute_magnitude_h":{"title":"Is a measure of an asteroids brightness","type":"number","format":"double"},"estimated_diameter":{"$ref":"#/components/schemas/EstimatedDiameterContainer"},"is_potentially_hazardous_asteroid":{"type":"boolean"},"close_approach_data":{"title":"Close approach information of the Asteroid","type":"array","items":{"$ref":"#/components/schemas/CloseApproachData"}},"orbital_data":{"$ref":"#/components/schemas/OrbitalData"},"is_sentry_object":{"type":"boolean"},"sentry_data":{"type":"string"}}},"OrbitClass":{"type":"object","properties":{"orbit_class_type":{"type":"string","enum":["IEO","ATE","APO","AMO","MCA","IMB","MBA","OMB","TJN","CEN","TNO","PAA","HYA","HYP","PAR","COM","JFC","HTC","ETC","CTC","JFc"]},"orbit_class_description":{"type":"string"},"orbit_class_range":{"type":"string"}}},"OrbitalData":{"title":"Orbital information of t1he asteroid","type":"object","properties":{"orbit_id":{"type":"string"},"orbit_determination_date":{"type":"string"},"first_observation_date":{"type":"string"},"last_observation_date":{"type":"string"},"data_arc_in_days":{"type":"integer","format":"int64"},"observations_used":{"type":"integer","format":"int64"},"orbit_uncertainty":{"type":"string"},"minimum_orbit_intersection":{"type":"string"},"jupiter_tisserand_invariant":{"type":"string"},"epoch_osculation":{"type":"string"},"eccentricity":{"type":"string"},"semi_major_axis":{"type":"string"},"inclination":{"type":"string"},"ascending_node_longitude":{"type":"string"},"orbital_period":{"type":"string"},"perihelion_distance":{"type":"string"},"perihelion_argument":{"type":"string"},"aphelion_distance":{"type":"string"},"perihelion_time":{"type":"string"},"mean_anomaly":{"type":"string"},"mean_motion":{"type":"string"},"equinox":{"type":"string"},"orbit_class":{"$ref":"#/components/schemas/OrbitClass"}}},"RelVelocity":{"type":"object","properties":{"kilometers_per_second":{"type":"string"},"kilometers_per_hour":{"type":"string"},"miles_per_hour":{"type":"string"}}},"PageMetaData":{"type":"object","properties":{"size":{"type":"integer","format":"int64"},"total_elements":{"type":"integer","format":"int64"},"total_pages":{"type":"integer","format":"int64"},"number":{"type":"integer","format":"int64"}}},"PageSentryImpactRiskObject":{"type":"object","properties":{"totalPages":{"type":"integer","format":"int32"},"totalElements":{"type":"integer","format":"int64"},"size":{"type":"integer","format":"int32"},"content":{"type":"array","items":{"$ref":"#/components/schemas/SentryImpactRiskObject"}},"number":{"type":"integer","format":"int32"},"sort":{"$ref":"#/components/schemas/SortObject"},"first":{"type":"boolean"},"last":{"type":"boolean"},"pageable":{"$ref":"#/components/schemas/PageableObject"},"numberOfElements":{"type":"integer","format":"int32"},"empty":{"type":"boolean"}}},"PageableObject":{"type":"object","properties":{"offset":{"type":"integer","format":"int64"},"sort":{"$ref":"#/components/schemas/SortObject"},"pageNumber":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"paged":{"type":"boolean"},"unpaged":{"type":"boolean"}}},"SentryImpactRiskObject":{"type":"object","properties":{"links":{"type":"object","additionalProperties":{"type":"string","readOnly":true},"readOnly":true},"spkId":{"type":"string","readOnly":true},"designation":{"type":"string"},"sentryId":{"type":"string"},"fullname":{"type":"string"},"year_range_min":{"type":"string"},"year_range_max":{"type":"string"},"potential_impacts":{"type":"string"},"impact_probability":{"type":"string"},"v_infinity":{"type":"string"},"absolute_magnitude":{"type":"string"},"estimated_diameter":{"type":"string"},"palermo_scale_ave":{"type":"string"},"Palermo_scale_max":{"type":"string"},"torino_scale":{"type":"string"},"last_obs":{"type":"string"},"last_obs_jd":{"type":"string"},"url_nasa_details":{"type":"string"},"url_orbital_elements":{"type":"string"},"is_active_sentry_object":{"type":"boolean"},"removal_date":{"type":"string"},"url_impact_details":{"type":"string"},"url_orbital_element_details":{"type":"string"},"average_lunar_distance":{"type":"number","format":"double"}}},"SentryObjectPagingDto":{"type":"object","properties":{"upPage":{"$ref":"#/components/schemas/PageSentryImpactRiskObject"},"links":{"type":"object","additionalProperties":{"type":"string"}},"page":{"$ref":"#/components/schemas/PageMetaData"},"sentry_objects":{"type":"array","items":{"$ref":"#/components/schemas/SentryImpactRiskObject"}}}},"SortObject":{"type":"object","properties":{"sorted":{"type":"boolean"},"empty":{"type":"boolean"},"unsorted":{"type":"boolean"}}},"Link":{"type":"object","properties":{"href":{"type":"string"},"hreflang":{"type":"string"},"title":{"type":"string"},"type":{"type":"string"},"deprecation":{"type":"string"},"profile":{"type":"string"},"name":{"type":"string"},"templated":{"type":"boolean"}}},"NearEarthObjectRestPagingDto":{"type":"object","properties":{"upPage":{"$ref":"#/components/schemas/PageNearEarthObject"},"upLinks":{"type":"array","writeOnly":true,"items":{"$ref":"#/components/schemas/Link"}},"links":{"type":"object","additionalProperties":{"type":"string"}},"page":{"$ref":"#/components/schemas/PageMetaData"},"near_earth_objects":{"type":"array","items":{"$ref":"#/components/schemas/NearEarthObject"}}}},"PageNearEarthObject":{"type":"object","properties":{"totalPages":{"type":"integer","format":"int32"},"totalElements":{"type":"integer","format":"int64"},"size":{"type":"integer","format":"int32"},"content":{"type":"array","items":{"$ref":"#/components/schemas/NearEarthObject"}},"number":{"type":"integer","format":"int32"},"sort":{"$ref":"#/components/schemas/SortObject"},"first":{"type":"boolean"},"last":{"type":"boolean"},"pageable":{"$ref":"#/components/schemas/PageableObject"},"numberOfElements":{"type":"integer","format":"int32"},"empty":{"type":"boolean"}}},"NearEarthObjectRestDto":{"title":"NearEarthObjectList","type":"object","properties":{"links":{"title":"Hypermedia links to collection","type":"object","additionalProperties":{"title":"Hypermedia links to collection","type":"string"}},"element_count":{"title":"Number of NEOs in list","type":"integer","format":"int32"},"near_earth_objects":{"title":"A collection of NearEarthObjects","type":"object","additionalProperties":{"title":"A collection of NearEarthObjects","type":"array","items":{"$ref":"#/components/schemas/NearEarthObject"}}}}}},"securitySchemes":{"api_key":{"type":"apiKey","description":"Api Key","name":"api_key","in":"query"}}}}